/*
 */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <signal.h>
#include <setjmp.h>
#include <sys/file.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <errno.h>
#include <pwd.h>
#include <ctype.h>
#include <time.h>
#include "defs.h"
#include "struct.h"


#if defined(__STDC__) || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

void openmem P_((void));
void log P_((struct _iobuf *fo, struct message *m));

#ifdef USE_SYS_PROTOS
extern int                    shmget P_((key_t, int, int));
extern void                   perror P_((const char *));
extern int                    fprintf P_((FILE *, const char *, ...));
extern void *                 shmat P_((int, void *, int));
extern unsigned int           sleep P_((unsigned int));
extern int                    shmctl P_((int, int, ...));
extern time_t                 time P_((time_t *));
extern int                    printf P_((const char *, ...));
#endif

#undef P_

int             shmid;
int		t_only=0;	/* only during t-mode */
struct memory  *sharedMemory;

void
openmem()
{
   extern int      errno;
   int             shmemKey = PKEY;

   errno = 0;
   shmid = shmget(shmemKey, 0, 0);
   if (shmid < 0) {
      if (errno != ENOENT) {
	 perror("shmget");
	 exit(1);
      }
      shmid = shmget(shmemKey, 0, 0);
      if (shmid < 0) {
	 fprintf(stderr, "dumpshmem: Daemon not running\n");
	 exit(1);
      }
   }
   sharedMemory = (struct memory *) shmat(shmid, 0, 0);
   if (sharedMemory == (struct memory *) - 1) {
      perror("shmat");
      exit(1);
   }
}

void
main(argc, argv)
   int             argc;
   char           *argv[];
{
   openmem();

   printf("\nstatus:\n");
   printf("  %-20s%d\n", "active:", sharedMemory->status[0].active);
   printf("  %-20s%d\n", "answer:", sharedMemory->status[0].answer);
   printf("  %-20s%d\n", "armsbomb:", sharedMemory->status[0].armsbomb);
   printf("  %-20s%d\n", "count:", sharedMemory->status[0].count);
#ifdef BASEPRACTICE
   printf("  %-20s%f\n", "dami:", sharedMemory->status[0].dami);
   printf("  %-20s%f\n", "damr:", sharedMemory->status[0].damr);
#endif
   printf("  %-20s%d\n", "gameup:", sharedMemory->status[0].gameup);
   printf("  %-20s%d\n", "kills:", sharedMemory->status[0].kills);
   printf("  %-20s%d\n", "losses:", sharedMemory->status[0].losses);
   printf("  %-20s%d\n", "number:", sharedMemory->status[0].number);
   printf("  %-20s%d\n", "planets:", sharedMemory->status[0].planets);
   printf("  %-20s%d\n", "request:", sharedMemory->status[0].request);
   printf("  %-20s%d\n", "time:", sharedMemory->status[0].time);
   printf("  %-20s%ud\n", "timeprod:", sharedMemory->status[0].timeprod);
   printf("  %-20s%d\n", "tourn:", (int)sharedMemory->status[0].tourn);
   printf("  %-20s%d\n", "wait:", sharedMemory->status[0].wait);

   printf("\nplayers:\n");
   {
      register	i;
      register struct player	*j;

      for(i=0,j=sharedMemory->players; i< MAXPLAYER; i++,j++){
	 printf("\n  %-20s%d\n", "p_no:", j->p_no);
	 printf("  %-20s%d\n", "p_updates:", j->p_updates);
	 printf("  %-20s%d\n", "p_status:", j->p_status);
	 printf("  %-20s%0x\n", "p_flags:", j->p_flags);
	 printf("  %-20s\"%s\"\n", "p_name:", j->p_name);
	 printf("  %-20s\"%s\"\n", "p_login:", j->p_login);
#ifdef LONGHOST
	 printf("  %-20s\"%s\"\n", "p_monitor:", j->p_monitor);
#endif
	 printf("  %-20s\"%s\"\n", "p_mapchars:", j->p_mapchars);

	 printf("    %-18s%d\n", "s_turns:", j->p_ship.s_turns);
	 printf("    %-18s%d\n", "s_accs:", (int)j->p_ship.s_accs);
	 printf("    %-18s%d\n", "s_torpdamage:", (int)j->p_ship.s_torpdamage);
	 printf("    %-18s%d\n", "s_phaserdamage:", (int)j->p_ship.s_phaserdamage);
	 printf("    %-18s%d\n", "s_phaserfuse:", (int)j->p_ship.s_phaserfuse);
	 printf("    %-18s%d\n", "s_plasmadamage:", (int)j->p_ship.s_plasmadamage);
	 printf("    %-18s%d\n", "s_torpspeed:", (int)j->p_ship.s_torpspeed);
	 printf("    %-18s%d\n", "s_torpfuse:", (int)j->p_ship.s_torpfuse);
	 printf("    %-18s%d\n", "s_plasmaspeed:", (int)j->p_ship.s_plasmaspeed);
	 printf("    %-18s%d\n", "s_plasmafuse:", (int)j->p_ship.s_plasmafuse);
	 printf("    %-18s%d\n", "s_plasmaturns:", (int)j->p_ship.s_plasmaturns);
	 printf("    %-18s%d\n", "s_maxspeed:", (int)j->p_ship.s_maxspeed);
	 printf("    %-18s%d\n", "s_repair:", (int)j->p_ship.s_repair);
	 printf("    %-18s%d\n", "s_maxfuel:", (int)j->p_ship.s_maxfuel);
	 printf("    %-18s%d\n", "s_torpcost:", (int)j->p_ship.s_torpcost);
	 printf("    %-18s%d\n", "s_plasmacost:", (int)j->p_ship.s_plasmacost);
	 printf("    %-18s%d\n", "s_phasercost:", (int)j->p_ship.s_phasercost);
	 printf("    %-18s%d\n", "s_detcost:", (int)j->p_ship.s_detcost);
	 printf("    %-18s%d\n", "s_warpcost:", (int)j->p_ship.s_warpcost);
	 printf("    %-18s%d\n", "s_cloakcost:", (int)j->p_ship.s_cloakcost);
	 printf("    %-18s%d\n", "s_recharge:", (int)j->p_ship.s_recharge);
	 printf("    %-18s%d\n", "s_accint:", (int)j->p_ship.s_accint);
	 printf("    %-18s%d\n", "s_decint:", (int)j->p_ship.s_decint);
	 printf("    %-18s%d\n", "s_maxshield:", (int)j->p_ship.s_maxshield);
	 printf("    %-18s%d\n", "s_maxdamage:", (int)j->p_ship.s_maxdamage);
	 printf("    %-18s%d\n", "s_maxegntemp:", (int)j->p_ship.s_maxegntemp);
	 printf("    %-18s%d\n", "s_maxwpntemp:", (int)j->p_ship.s_maxwpntemp);
	 printf("    %-18s%d\n", "s_egncoolrate:", (int)j->p_ship.s_egncoolrate);
	 printf("    %-18s%d\n", "s_wpncoolrate:", (int)j->p_ship.s_wpncoolrate);
	 printf("    %-18s%d\n", "s_maxarmies:", (int)j->p_ship.s_maxarmies);
	 printf("    %-18s%d\n", "s_width:", (int)j->p_ship.s_width);
	 printf("    %-18s%d\n", "s_height:", (int)j->p_ship.s_height);
	 printf("    %-18s%d\n", "s_type:", (int)j->p_ship.s_type);
	 printf("    %-18s%d\n", "s_mass:", (int)j->p_ship.s_mass);
	 printf("    %-18s%d\n", "s_tractstr:", (int)j->p_ship.s_tractstr);
	 printf("    %-18s%d\n", "s_tractrng:", (int)j->p_ship.s_tractrng);

	 printf("  %-20s%d\n", "p_x:", j->p_x);
	 printf("  %-20s%d\n", "p_y:", j->p_y);
	 printf("  %-20s%d\n", "p_dir:", (int)j->p_dir);
	 printf("  %-20s%d\n", "p_desdir:", (int)j->p_desdir);
	 printf("  %-20s%d\n", "p_subdir:", (int)j->p_subdir);
	 printf("  %-20s%d\n", "p_speed:", (int)j->p_speed);
	 printf("  %-20s%d\n", "p_desspeed:", (int)j->p_desspeed);
	 printf("  %-20s%d\n", "p_subspeed:", (int)j->p_subspeed);
	 printf("  %-20s%d\n", "p_team:", (int)j->p_team);
	 printf("  %-20s%d\n", "p_damage:", (int)j->p_damage);
	 printf("  %-20s%d\n", "p_subdamage:", (int)j->p_subdamage);
	 printf("  %-20s%d\n", "p_shield:", (int)j->p_shield);
	 printf("  %-20s%d\n", "p_subshield:", (int)j->p_subshield);
	 printf("  %-20s%d\n", "p_cloakphase:", (int)j->p_cloakphase);
	 printf("  %-20s%d\n", "p_ntorp:", (int)j->p_ntorp);
	 printf("  %-20s%d\n", "p_nplasmatorp:", (int)j->p_nplasmatorp);
	 printf("  %-20s%d\n", "p_hostile:", (int)j->p_hostile);
	 printf("  %-20s%d\n", "p_swar:", (int)j->p_swar);
	 printf("  %-20s%f\n", "p_kills:", j->p_kills);
	 printf("  %-20s%d\n", "p_planet:", (int)j->p_planet);
	 printf("  %-20s%d\n", "p_playerl:", (int)j->p_playerl);
	 printf("  %-20s%d\n", "p_armies:", (int)j->p_armies);
	 printf("  %-20s%d\n", "p_fuel:", (int)j->p_fuel);
	 printf("  %-20s%d\n", "p_explode:", (int)j->p_explode);
	 printf("  %-20s%d\n", "p_etemp:", (int)j->p_etemp);
	 printf("  %-20s%d\n", "p_etime:", (int)j->p_etime);
	 printf("  %-20s%d\n", "p_wtemp:", (int)j->p_wtemp);
	 printf("  %-20s%d\n", "p_wtime:", (int)j->p_wtime);
	 printf("  %-20s%d\n", "p_whydead:", (int)j->p_whydead);
	 printf("  %-20s%d\n", "p_whodead:", (int)j->p_whodead);

	 printf("    %-18s%f\n", "st_maxkills:",	j->p_stats.st_maxkills);
	 printf("    %-18s%d\n", "st_kills:",	j->p_stats.st_kills);
	 printf("    %-18s%d\n", "st_losses:",	j->p_stats.st_losses);
	 printf("    %-18s%d\n", "st_armsbomb:",	j->p_stats.st_armsbomb);
	 printf("    %-18s%d\n", "st_planets:",	j->p_stats.st_planets);
	 printf("    %-18s%d\n", "st_ticks:",	j->p_stats.st_ticks);
	 printf("    %-18s%d\n", "st_tkills:",	j->p_stats.st_tkills);
	 printf("    %-18s%d\n", "st_tlosses:",	j->p_stats.st_tlosses);
	 printf("    %-18s%d\n", "st_tarmsbomb:",	j->p_stats.st_tarmsbomb);
	 printf("    %-18s%d\n", "st_tplanets:",	j->p_stats.st_tplanets);
	 printf("    %-18s%d\n", "st_tticks:",	j->p_stats.st_tticks);
	 printf("    %-18s%d\n", "st_sbkills:",	j->p_stats.st_sbkills);
	 printf("    %-18s%d\n", "st_sblosses:",	j->p_stats.st_sblosses);
	 printf("    %-18s%d\n", "st_sbticks:",	j->p_stats.st_sbticks);
	 printf("    %-18s%f\n", "st_sbmaxkills:",	j->p_stats.st_sbmaxkills);
	 printf("    %-18s%d\n", "st_lastlogin:",	j->p_stats.st_lastlogin);
	 printf("    %-18s%ud\n", "st_flags:",	j->p_stats.st_flags);
	 printf("    %-18s%s\n", "st_keymap:",	j->p_stats.st_keymap);
	 printf("    %-18s%d\n", "st_rank:",	j->p_stats.st_rank);
#ifdef BASEPRACTICE
	 printf("    %-18s%f\n", "st_dami:",	j->p_stats.st_dami);
	 printf("    %-18s%f\n", "st_damr:",	j->p_stats.st_damr);
#endif
	 printf("  %-20s%d\n", "p_genoplanets:", (int)j->p_genoplanets);
	 printf("  %-20s%d\n", "p_genoarmsbomb:", (int)j->p_genoarmsbomb);
	 printf("  %-20s%d\n", "p_planets:", (int)j->p_planets);
	 printf("  %-20s%d\n", "p_armsbomb:", (int)j->p_armsbomb);
	 printf("  %-20s%d\n", "p_ghostbuster:", (int)j->p_ghostbuster);
	 printf("  %-20s%d\n", "p_docked:", (int)j->p_docked);

#ifdef SB_DOCK
	 printf("  %-20s%d\n", "p_numdocked:", (int)j->p_numdocked);
	 printf("  %-20s%d\n", "p_portdocked:", (int)j->p_portdocked);
#endif
	 printf("  %-20s%d,%d,%d,%d\n", "p_port:", 
		j->p_port[0], j->p_port[1], j->p_port[2], j->p_port[3]);
	 printf("  %-20s%d\n", "p_tractor:", (int)j->p_tractor);
	 printf("  %-20s%d\n", "p_pos:", (int)j->p_pos);
	 printf("  %-20s%d\n", "p_avrt:", (int)j->p_avrt);
	 printf("  %-20s%d\n", "p_stdv:", (int)j->p_stdv);
	 printf("  %-20s%d\n", "p_pkls_s_c:", (int)j->p_pkls_s_c);
	 printf("  %-20s%d\n", "p_pkls_c_s:", (int)j->p_pkls_c_s);

#ifdef BASEPRACTICE
	 printf("  %-20s%d\n", "p_df:", (int)j->p_df);
	 printf("  %-20s%d\n", "p_tg:", (int)j->p_tg);
#endif
   
#ifdef DS
	 printf("  %-20s%d\n", "p_timerdelay:", (int)j->p_timerdelay);
	 printf("  %-20s%d\n", "p_process:", (int)j->p_process);
#endif
      }
   }

   printf("\ntorps:\n");
   {
      register	i;
      register struct torp	*k;

      for(i=0,k=sharedMemory->torps;i< MAXPLAYER*MAXTORP; i++,k++){
	 printf("\n  %-20s%d\n", "t_no:", (int)k->t_no);
	 printf("  %-20s%d\n", "t_status:", (int)k->t_status);
	 printf("  %-20s%d\n", "t_owner:", (int)k->t_owner);
	 printf("  %-20s%d\n", "t_x:", (int)k->t_x);
	 printf("  %-20s%d\n", "t_y:", (int)k->t_y);
	 printf("  %-20s%d\n", "t_dir:", (int)k->t_dir);
	 printf("  %-20s%d\n", "t_turns:", (int)k->t_turns);
	 printf("  %-20s%d\n", "t_damage:", (int)k->t_damage);
	 printf("  %-20s%d\n", "t_speed:", (int)k->t_speed);
	 printf("  %-20s%d\n", "t_fuse:", (int)k->t_fuse);
	 printf("  %-20s%d\n", "t_war:", (int)k->t_war);
	 printf("  %-20s%d\n", "t_team:", (int)k->t_team);
	 printf("  %-20s%d\n", "t_whodet:", (int)k->t_whodet);
#ifdef MINES
	 printf("  %-20s%d\n", "t_mine:", (int)k->t_mine);
	 printf("  %-20s%d\n", "t_pair:", (int)k->t_pair);
#endif
      }
   }

   printf("\nplasmatorps:\n");
   {
      register	i;
      register struct plasmatorp	*j;

      for(i=0,j=sharedMemory->plasmatorps; i<MAXPLAYER*MAXPLASMA; i++,j++){
	 printf("\n  %-20s%d\n", "pt_no:", (int)j->pt_no);
	 printf("  %-20s%d\n", "pt_status:", (int)j->pt_status);
	 printf("  %-20s%d\n", "pt_owner:", (int)j->pt_owner);
	 printf("  %-20s%d\n", "pt_x:", (int)j->pt_x);
	 printf("  %-20s%d\n", "pt_y:", (int)j->pt_y);
	 printf("  %-20s%d\n", "pt_dir:", (int)j->pt_dir);
	 printf("  %-20s%d\n", "pt_turns:", (int)j->pt_turns);
	 printf("  %-20s%d\n", "pt_damage:", (int)j->pt_damage);
	 printf("  %-20s%d\n", "pt_speed:", (int)j->pt_speed);
	 printf("  %-20s%d\n", "pt_fuse:", (int)j->pt_fuse);
	 printf("  %-20s%d\n", "pt_war:", (int)j->pt_war);
	 printf("  %-20s%d\n", "pt_team:", (int)j->pt_team);
      }
   }

   printf("\nplanets:\n");
   {
      register	i;
      register struct planet	*j;

      for(i=0,j=sharedMemory->planets; i< MAXPLANETS; i++,j++){
	 printf("\n  %-20s%d\n", "pl_no:", (int)j->pl_no);
	 printf("  %-20s%ud\n", "pl_flags:", j->pl_flags);
	 printf("  %-20s%d\n", "pl_owner:", (int)j->pl_owner);
	 printf("  %-20s%d\n", "pl_x:", (int)j->pl_x);
	 printf("  %-20s%d\n", "pl_y:", (int)j->pl_y);
	 printf("  %-20s%s\n", "pl_name:", j->pl_name);
	 printf("  %-20s%d\n", "pl_namelen:", (int)j->pl_namelen);
	 printf("  %-20s%d\n", "pl_armies:", (int)j->pl_armies);
	 printf("  %-20s%d\n", "pl_info:", (int)j->pl_info);
	 printf("  %-20s%d\n", "pl_deadtime:", (int)j->pl_deadtime);
	 printf("  %-20s%d\n", "pl_couptime:", (int)j->pl_couptime);
      }
   }

   printf("\nphasers:\n");
   {
      register	i;
      register struct phaser	*j;

      for(i=0,j=sharedMemory->phasers; i< MAXPLAYER; i++,j++){
	 printf("\n  %-20s%d\n", "phaser", i);
	 printf("    %-18s%d\n", "ph_status:", (int)j->ph_status);
	 printf("    %-18s%d\n", "ph_dir:", (int)j->ph_dir);
	 printf("    %-18s%d\n", "ph_target:", (int)j->ph_target);
	 printf("    %-18s%d\n", "ph_x:", (int)j->ph_x);
	 printf("    %-18s%d\n", "ph_y:", (int)j->ph_y);
	 printf("    %-18s%d\n", "ph_fuse:", (int)j->ph_fuse);
	 printf("    %-18s%d\n", "ph_damage:", (int)j->ph_damage);
      }
   }

   printf("\nmctl: %d\n", sharedMemory->mctl[0].mc_current);

   printf("\nmessages:\n");
   {
      register	i;
      register struct message	*m;

      for(i=0,m=sharedMemory->messages; i< MAXMESSAGE; i++,m++){
	 printf("\n  %-20s%d\n", "m_no:", (int)m->m_no);
	 printf("  %-20s%ud\n", "m_flags:", m->m_flags);
	 printf("  %-20s%d\n", "m_time:", (int)m->m_time);
	 printf("  %-20s%d\n", "m_recpt:", (int)m->m_recpt);
	 printf("  %-20s\"%s\"\n", "m_data:", m->m_data);
	 printf("  %-20s%d\n", "m_from:", (int)m->m_from);
      }
   }

   printf("\nteams:\n");
   {
      register	i;
      struct team	*t;
      for(i=0,t=sharedMemory->teams; i < MAXTEAM+1; i++,t++){
	 printf("\n  %-20s%d\n", "team", i);
	 printf("    %-18s%d\n", "s_turns:", t->s_turns);
	 printf("    %-18s%d\n", "s_surrender:", t->s_surrender);
	 printf("    %-18s%d\n", "s_plcount:", t->s_plcount);
      }
   }

   exit(0);
}
